#ifndef MINIMAX_H_
#define MINIMAX_H_
// CONVERTED ALL GLOBALS TO CONSTANTS FOR SPEED AND SIZE
#define ZERO 0
#define ONE 1
#define TWO 2
#define minusone  1048575   //#FFFFF
#define DO_ERROR_EXIT -3
#define Insufficient_Memory 1 	// #001 err number in HP
#define Bad_range_value 1879 	// #757 err number in HP, used for memory de-allocation 
#define Interrupted 319		// #13F err number in HP
#define Too_Few_Arguments 513	// #201 err number in HP
#define Bad_Argument_Type 514	// #202 err number in HP
#define Bad_Argument_Value 515	// #203 err number in HP
#define Infinite_Result 773  	// #305 err number in HP
#define Invalid_Dimensions 1281	// #501 err number in HP
#define Unable_to_find_root 49153// #C001 err number in HP
BOOL sat_push_double_vector(int elements,double *vector);
double ** sat_create_pop_double_matrix(int *m,int *n);
double **create_matrix2(int maxm, int maxn);
double *  create_vector(int n);
int * create_int_vector(int n);
void free_matrix2(int m,int n,double **a);
void	const_matrix(int m, int n, double r, double **mat);
void	const_vector(int n, double r, double v[]);
void    const_intmatrix(int m, int n, int c, int **cmat); 
/*  building blocks eispack, lapack, etc. */
int dgefa(int n, double **a  /* [][n] */ , int ipvt[]);
void dgesl( int m, int n, double **a /* [][n] */ ,int ipvt[],double **b /* [][n] */,int job);

/* minimax project */
int do_minimax();
int minimax(double *pol, double **data, double *c, double e,int m, int n);
int spolmm(double *u, double *v, double *a,int l);
double fnf(double *pol, double x, int n);
int fns(double *pol, int n,double *u, double *v, int i);
int fsign( double x);
void vec_fnerr(double *d, int n, double *pol, double **data, int np);
int fmaxabs(double *d, int n);
int push_result_to_stack(int n, double error, double *pol);

#endif /*MINIMAX_H_*/
